"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prefix_1 = __importDefault(require("./prefix"));
class User {
    modes;
    // Users in the channel have only one mode assigned
    away;
    nick;
    lastMessage;
    constructor(attr, prefix) {
        this.modes = [];
        this.away = "";
        this.nick = "";
        this.lastMessage = 0;
        if (attr) {
            Object.assign(this, attr);
        }
        this.setModes(this.modes, prefix || new prefix_1.default([]));
    }
    get mode() {
        return this.modes[0] || "";
    }
    setModes(modes, prefix) {
        // irc-framework sets character mode, but The Lounge works with symbols
        this.modes = modes.map((mode) => prefix.modeToSymbol[mode]);
    }
    toJSON() {
        return {
            nick: this.nick,
            modes: this.modes,
            lastMessage: this.lastMessage,
        };
    }
}
exports.default = User;
